! This program create 1D filters to match two waveforms
! input : original waveform
! output: target waveform
! filter: desired filter 

program main
  use base_fftwv3_mod
  use hamming_window_mod
  use create_filter_mod
  use sep
  implicit none

  integer  :: nw1, nw2, nw3, nw4
  integer  :: iw, it, ifilter
  integer  :: nt, nw, ntau, nfilter 
  integer*8:: plan_1dt1, plan_1dt2, plan_1dt3
  real     :: ot, ow, otau, ofilter
  real     :: dt, dw, eps, dtau, dfilter
  real     :: f1, f2, f3, f4, w1, w2, w3, w4
  real   , dimension(:,:)    , allocatable :: filter
  real   , dimension(:,:)    , allocatable :: input
  real   , dimension(:)      , allocatable :: match 
  logical  :: adj
  logical  :: radian
  logical  :: wnttap
  real, parameter :: PI = 3.14159265359
  integer  :: stat


  call initpar()

  call from_param("f1", f1,  5.)
  call from_param("f2", f2, 10.)
  call from_param("f3", f3, 35.)
  call from_param("f4", f4, 40.)

  call from_param("adj", adj, .true.)
  call from_param("eps", eps, 0.0001)
  call from_param("radian", radian, .true.)
  call from_param("wnttap", wnttap, .true.)

  call from_history("n1",  ntau); call from_history("d1",  dtau); call from_history("o1",  otau)
  call from_history("n2",  nt)  ; call from_history("d2",  dt)  ; call from_history("o2",  ot)

  call from_param("dfilter", dfilter, 1.)
  call from_param("ofilter", ofilter, ot)
  call from_param("nfilter", nfilter, 14)

  stat = create_filter_init(ntau, otau, dtau, f1, f2, f3, f4, radian, eps, wnttap) 

  allocate(input(ntau,nt), filter(ntau,nfilter), match(ntau))
  input = 0; filter = 0; match = 0;
  call sreed("in"   , input, 4*ntau*nt)
  call sreed("match", match, 4*ntau   )
  
  do ifilter= 1, nfilter
    it = ( (ifilter-1) * dfilter + ofilter - ot ) / dt + 1.5
    call create_filter(input(:,it), match, filter(:,ifilter), .false.)
  end do

  call srite("out", filter, 4*ntau*nfilter)
  call to_history("n1",ntau)
  call to_history("d1",dtau)
  call to_history("o1",otau)
  call to_history("n2",nfilter)
  call to_history("d2",dfilter)
  call to_history("o2",ofilter)

  stat = create_filter_clos()
  
  deallocate(input , match, filter )

end program
