module fourier_modOMP1D

  implicit none
  include "fftw3.f"

  integer, private                             :: n1
  integer*8, private                           :: plan1f, plan1b
  contains

  subroutine ft_init1D(n1_in,in1,out1)
    integer               :: n1_in
    complex, dimension(:)  :: in1,out1

    n1 = n1_in
    call sfftw_plan_dft_1d(plan1f, n1, in1, out1, FFTW_FORWARD, FFTW_ESTIMATE)
    call sfftw_plan_dft_1d(plan1b, n1, out1, in1, FFTW_BACKWARD, FFTW_ESTIMATE)
  end subroutine

  subroutine ft1axis(adj, sign1, cdata,in1,out1)
    logical, intent(in)        :: adj
    integer                    :: i2
    complex, dimension(:) :: cdata
    real                       :: sign1
    complex, dimension(:)  :: in1,out1    

    if(adj) then
        out1(1:(n1+1)/2) = cdata(n1-(n1+1)/2+1:n1)
        out1((n1+1)/2+1:n1) = cdata(1:n1-(n1+1)/2)
        call sfftw_execute_dft(plan1b, out1, in1)
        cdata(1:n1) = in1(1:n1)
    else
        in1(1:n1) = cdata(1:n1)
        call sfftw_execute_dft(plan1f, in1, out1)
        cdata(1:n1) = out1(1:n1)
        cdata(1:n1-(n1+1)/2) = out1((n1+1)/2+1:n1)
        cdata(n1-(n1+1)/2+1:n1) = out1(1:(n1+1)/2)
    endif
    cdata(1:n1) = sign1*cdata(1:n1)/sqrt(1.*n1)
  end subroutine

end module
